package naunton.space.jdbc.CAJDBCSqlDriverWrapper;

import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.DriverPropertyInfo;
import java.sql.SQLException;
import java.util.Properties;


// Wraps com.ca.ppm.clients.jdbc.CAJDBCDriver and loads com.microsoft.sqlserver.jdbc.SQLServerDriver

public class DriverWrapper implements Driver {
	private Driver mWrappedDriver;

	static {
		try {
			DriverManager.registerDriver(new DriverWrapper());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public DriverWrapper() throws SQLException {
		try {
			// Wrap com.ca.ppm.clients.jdbc.CAJDBCDriver
			Class c = Class.forName("com.ca.ppm.clients.jdbc.CAJDBCDriver");
			mWrappedDriver = (Driver) c.newInstance();

			// Load the sql server driver class
			Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	public boolean acceptsURL(String url) throws SQLException {
		return mWrappedDriver.acceptsURL(url);
	}

	public Connection connect(String url, Properties info) throws SQLException {
		return mWrappedDriver.connect(url, info);
	}
    
	public DriverPropertyInfo[] getPropertyInfo(String url, Properties info) throws SQLException {
 		return mWrappedDriver.getPropertyInfo(url, info);
	}

	public int getMajorVersion() {
		return mWrappedDriver.getMajorVersion();
	}

	public int getMinorVersion() {
		return mWrappedDriver.getMinorVersion();
	}

	public boolean jdbcCompliant() {
		return mWrappedDriver.jdbcCompliant();
	}

// Uncomment this function if compiling with java >= 1.7.
//	public Logger getParentLogger() throws SQLFeatureNotSupportedException  {
//		return mWrappedDriver.getParentLogger();
//	}
}
